"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScriptController = void 0;
const common_1 = require("@nestjs/common");
const script_service_1 = require("./script.service");
const create_script_dto_1 = require("./dto/create-script.dto");
const commonServices_1 = require("../services/commonServices");
const platform_express_1 = require("@nestjs/platform-express");
const multer_1 = require("multer");
const path_1 = require("path");
const passport_1 = require("@nestjs/passport");
let ScriptController = class ScriptController {
    constructor(scriptService, commonServices) {
        this.scriptService = scriptService;
        this.commonServices = commonServices;
    }
    async addScript(scriptData, script_video, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return await this.scriptService.addScript(scriptData, req.user.userId, script_video, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async updateScript(scriptData, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.updateScript(req.user.userId, scriptData, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async deleteScript(scriptData, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.deleteScript(scriptData._id, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async addScriptVideo(scriptData, script_video, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.addVideo(scriptData, script_video, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async getScriptById(scriptData, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.getScriptById(req.user.userId, scriptData._id, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async getAllScript(filterParams, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.getAllScript(req.user.userId, filterParams, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async addFavoriteScript(scriptData, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.favoriteScript(req.user.userId, scriptData, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
    async deleteScriptVideo(scriptData, req, res) {
        if (req.user.isUser === true) {
            let isValid = await this.commonServices.checkToken(req.headers.authorization.split(' ')[1]);
            if (isValid === false) {
                throw new common_1.UnauthorizedException();
            }
            return this.scriptService.deleteScriptVideo(req.user.userId, scriptData, res);
        }
        else {
            throw new common_1.UnauthorizedException();
        }
    }
};
exports.ScriptController = ScriptController;
__decorate([
    (0, common_1.Post)('addScript'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('script_video', {
        storage: (0, multer_1.diskStorage)({
            destination(req, file, cb) {
                if (file?.fieldname === 'script_video') {
                    if (!file.mimetype.match(/\/(mp4|avi|mkv|mov)$/)) {
                        cb(new common_1.HttpException(`Unsupported file type ${(0, path_1.extname)(file.originalname)}`, common_1.HttpStatus.BAD_REQUEST), 'false');
                    }
                }
                cb(null, process.env.VIDEO_PATH);
            },
            filename: async (req, file, callback) => {
                const extName = (0, path_1.extname)(file.originalname);
                const FinalPath = file.fieldname + '-' + Date.now() + extName;
                callback(null, FinalPath);
            },
        }),
    })),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.UploadedFile)()),
    __param(2, (0, common_1.Req)()),
    __param(3, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "addScript", null);
__decorate([
    (0, common_1.Post)('updateScript'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "updateScript", null);
__decorate([
    (0, common_1.Post)('deleteScript'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "deleteScript", null);
__decorate([
    (0, common_1.Post)('addScriptVideo'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('script_video', {
        storage: (0, multer_1.diskStorage)({
            destination(req, file, cb) {
                if (file?.fieldname === 'script_video') {
                    if (!file.mimetype.match(/\/(mp4|avi|mkv|mov)$/)) {
                        cb(new common_1.HttpException(`Unsupported file type ${(0, path_1.extname)(file.originalname)}`, common_1.HttpStatus.BAD_REQUEST), 'false');
                    }
                }
                cb(null, process.env.VIDEO_PATH);
            },
            filename: async (req, file, callback) => {
                const extName = (0, path_1.extname)(file.originalname);
                const FinalPath = file.fieldname + '-' + Date.now() + extName;
                callback(null, FinalPath);
            },
        }),
    })),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.UploadedFile)()),
    __param(2, (0, common_1.Req)()),
    __param(3, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "addScriptVideo", null);
__decorate([
    (0, common_1.Post)('getScriptById'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "getScriptById", null);
__decorate([
    (0, common_1.Post)('getAllScripts'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "getAllScript", null);
__decorate([
    (0, common_1.Post)('favoriteScript'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "addFavoriteScript", null);
__decorate([
    (0, common_1.Post)('deleteScriptVideo'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Req)()),
    __param(2, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_script_dto_1.CreateScriptDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ScriptController.prototype, "deleteScriptVideo", null);
exports.ScriptController = ScriptController = __decorate([
    (0, common_1.UseGuards)((0, passport_1.AuthGuard)('jwt')),
    (0, common_1.Controller)('script'),
    __metadata("design:paramtypes", [script_service_1.ScriptService,
        commonServices_1.commonServices])
], ScriptController);
//# sourceMappingURL=script.controller.js.map